import * as types from '@babel/types';
type TRequestBase = {
    source: string;
    from: string;
};
type TImportRequest = TRequestBase & {
    type: 'import';
    default?: string;
    specifiers: string[];
};
type TRequireRequest = TRequestBase & {
    type: 'require';
};
type TRequest = TImportRequest | TRequireRequest;
type TImportType = TRequest["type"];
type TUnresolvedRequest<ImportType extends TImportType = TImportType> = {
    source: string;
    from: string;
    type: ImportType;
};
type FileMatch = {
    filename: string;
    matches: string[];
};
type TTransformer = (request: TRequest, matches: FileMatch[], t: typeof types) => types.Statement[] | void;
type TTransformRule = {
    test: (request: TUnresolvedRequest) => boolean;
    globOnly?: boolean;
    replace: TTransformer;
};
type TOptions = {
    debug?: boolean;
    removeAliases?: (source: string) => string;
};
declare const ruleBuilder: (options: TOptions, rules: TTransformRule[]) => (typeof Plugin | {
    rules: TTransformRule[];
    debug?: boolean;
    removeAliases?: (source: string) => string;
})[];
export default ruleBuilder;
declare function Plugin(babel: any, { rules, debug, removeAliases }: TOptions & {
    rules: TTransformRule[];
}): PluginObj<{
    fichier: string;
}>;
