"use strict";
/*----------------------------------
- DEPENDANCES
----------------------------------*/
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
// Node
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var generator_1 = __importDefault(require("@babel/generator"));
var micromatch_1 = __importDefault(require("micromatch"));
/*----------------------------------
- WEBPACK RULE
----------------------------------*/
var ruleBuilder = function (options, rules) { return [Plugin, __assign(__assign({}, options), { rules: rules })]; };
exports["default"] = ruleBuilder;
/*----------------------------------
- PLUGIN
----------------------------------*/
function getFiles(dir) {
    var e_1, _a;
    var files = [];
    var dirents = fs_1["default"].readdirSync(dir, { withFileTypes: true });
    try {
        for (var dirents_1 = __values(dirents), dirents_1_1 = dirents_1.next(); !dirents_1_1.done; dirents_1_1 = dirents_1.next()) {
            var dirent = dirents_1_1.value;
            var res = path_1["default"].resolve(dir, dirent.name);
            if (dirent.isDirectory()) {
                files.push.apply(files, __spreadArray([], __read(getFiles(res)), false));
            }
            else {
                files.push(res);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (dirents_1_1 && !dirents_1_1.done && (_a = dirents_1["return"])) _a.call(dirents_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return files;
}
function Plugin(babel, _a) {
    var rules = _a.rules, debug = _a.debug, removeAliases = _a.removeAliases;
    var t = babel.types;
    var findFiles = function (request) {
        var e_2, _a;
        var containsGlob = request.source.includes('*');
        var matchingRule = rules.find(function (_a) {
            var test = _a.test, globOnly = _a.globOnly;
            return (test(request)
                &&
                    (globOnly === false
                        ||
                            containsGlob));
        });
        // Nothing to process here
        if (!matchingRule && !containsGlob)
            return null;
        var cheminGlob = request.source;
        // Chemin relatif => Transformation en absolu
        if (cheminGlob[0] === '.')
            cheminGlob = path_1["default"].resolve(path_1["default"].dirname(request.from), request.source);
        // Chemin absolu => Remplacement alias
        else if (removeAliases !== undefined)
            cheminGlob = removeAliases(request.source);
        // List files in the search directory
        var wildcardPos = cheminGlob.indexOf('*');
        var rootDir = cheminGlob.substring(0, wildcardPos);
        var allfiles = getFiles(rootDir);
        // Find matches + keep captured groups
        debug && console.log("Searching for files matching ".concat(request.source, " in directory ").concat(rootDir));
        var regex = micromatch_1["default"].makeRe(cheminGlob, { capture: true });
        var matchedFiles = [];
        try {
            for (var allfiles_1 = __values(allfiles), allfiles_1_1 = allfiles_1.next(); !allfiles_1_1.done; allfiles_1_1 = allfiles_1.next()) {
                var file = allfiles_1_1.value;
                var matches = file.match(regex);
                if (matches)
                    matchedFiles.push({ filename: file, matches: matches.slice(1) });
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (allfiles_1_1 && !allfiles_1_1.done && (_a = allfiles_1["return"])) _a.call(allfiles_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        debug && console.log('IMPORT GLOB', request.source, '=>', cheminGlob, matchingRule ? 'from rule' : '', matchedFiles);
        return { files: matchedFiles, replace: matchingRule === null || matchingRule === void 0 ? void 0 : matchingRule.replace };
    };
    var plugin = {
        pre: function (state) {
            this.fichier = state.opts.filename;
        },
        visitor: {
            // require("path")
            CallExpression: function (instruction) {
                var _a = instruction.node, callee = _a.callee, args = _a.arguments;
                if (!(callee.type === "Identifier" && callee.name === 'require'
                    &&
                        args.length === 1 && args[0].type === "StringLiteral"))
                    return;
                var chemin = args[0].value;
                // Glob
                var unresolvedRequest = {
                    type: 'require',
                    source: chemin,
                    from: this.fichier
                };
                var result = findFiles(unresolvedRequest);
                if (result === null)
                    return;
                var replace = result.replace, files = result.files;
                var replacement;
                if (replace !== undefined)
                    replacement = replace(unresolvedRequest, files, t);
                if (replacement === undefined) {
                    replacement = files.map(function (fichier) { return t.callExpression(t.identifier('require'), [t.stringLiteral(fichier.filename)]); });
                }
                /*debug && console.log(
                    generate(instruction.node).code,
                    '=>',
                    generate(t.program(replacement)).code,
                );*/
                instruction.replaceWithMultiple(replacement);
            },
            ImportDeclaration: function (instruction) {
                var e_3, _a, e_4, _b;
                var chemin = instruction.node.source.value;
                var unresolvedRequest = {
                    type: 'import',
                    source: chemin,
                    from: this.fichier
                };
                var result = findFiles(unresolvedRequest);
                if (result === null)
                    return;
                var replace = result.replace, files = result.files;
                // Référe,ncement des noms à importer
                var importDefault = undefined;
                var importClassique = [];
                var importAll = false;
                try {
                    for (var _c = __values(instruction.node.specifiers), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var specifier = _d.value;
                        /*
                            import templates from '@/earn/serveur/emails/*.hbs';
                            =>
                            import templates_notifications from '@/earn/serveur/emails/notifications.hbs';
                            import templates_inscription from '@/earn/serveur/emails/inscription.hbs';
                            const templates = {
                                notifications: templates_notifications,
                                inscription: templates_inscription,
                            }
                        */
                        if (specifier.type === 'ImportDefaultSpecifier') {
                            importDefault = specifier.local.name;
                            /*
                                import { notifications, inscription } from '@/earn/serveur/emails/*.hbs';
                                =>
                                import notifications from '@/earn/serveur/emails/notifications.hbs';
                                import inscription from '@/earn/serveur/emails/inscription.hbs';
                            */
                        }
                        else if (specifier.type === 'ImportSpecifier') {
                            importClassique.push(specifier.local.name);
                            /*
                                import * as templates from '@/earn/serveur/emails/*.hbs';
                                =>
                                import * as templates_notifications from '@/earn/serveur/emails/notifications.hbs';
                                import * as templates_inscription from '@/earn/serveur/emails/inscription.hbs';
                                const templates = {
                                    notifications: templates_notifications,
                                    inscription: templates_inscription,
                                }
                            */
                        }
                        else if (specifier.type === 'ImportNamespaceSpecifier') {
                            importDefault = specifier.local.name;
                            importAll = true;
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c["return"])) _a.call(_c);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
                var replacement;
                if (replace !== undefined)
                    replacement = replace(__assign(__assign({}, unresolvedRequest), { "default": importDefault, specifiers: importClassique }), files, t);
                if (replacement === undefined) {
                    // Recup liste files disponibles et création des importations
                    var nomImports = [];
                    replacement = [];
                    try {
                        for (var files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                            var fichier = files_1_1.value;
                            /// Exclusion du fichier actuel
                            if (fichier.filename === this.fichier)
                                continue;
                            // import <chemin>
                            if (instruction.node.specifiers.length === 0) {
                                replacement.push(t.importDeclaration([], t.stringLiteral(fichier.filename)));
                            }
                            else {
                                // Création nom d'importation via le nom du fichier
                                var posSlash = fichier.filename.lastIndexOf('/') + 1;
                                var posExt = fichier.filename.lastIndexOf('.');
                                var nomFichier = fichier.filename.substring(posSlash, posExt > posSlash ? posExt : undefined);
                                var nomFichierPourImport = fichier.matches.join('_');
                                //console.log({ posSlash, posExt, length: fichier.length, nomFichier });
                                var nomImport = void 0;
                                // import <nom> from <chemin>
                                if (importClassique.includes(nomFichier))
                                    nomImport = nomFichierPourImport;
                                // import <prefixe>_<nom> from <chemin>
                                else if (importDefault !== undefined) {
                                    nomImport = importDefault + '_' + nomFichierPourImport.replace(/[ \/]/g, '_');
                                    nomImports.push([nomImport, nomFichierPourImport]);
                                }
                                else
                                    continue;
                                // Création de l'importation
                                replacement.push(t.importDeclaration([importAll
                                        ? t.importNamespaceSpecifier(t.identifier(nomImport))
                                        : t.importDefaultSpecifier(t.identifier(nomImport))
                                ], t.stringLiteral(fichier.filename)));
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (files_1_1 && !files_1_1.done && (_b = files_1["return"])) _b.call(files_1);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    // Import default
                    if (importDefault !== undefined)
                        replacement.push(t.variableDeclaration('const', [
                            t.variableDeclarator(t.identifier(importDefault), t.objectExpression(nomImports.map(function (_a) {
                                var _b = __read(_a, 2), nomImport = _b[0], nomFichier = _b[1];
                                return t.objectProperty(t.stringLiteral(nomFichier), t.identifier(nomImport));
                            })))
                        ]));
                }
                debug && console.log((0, generator_1["default"])(instruction.node).code, '=>', replacement ? (0, generator_1["default"])(t.program(replacement)).code : 'void');
                instruction.replaceWithMultiple(replacement);
            }
        }
    };
    return plugin;
}
